package ch.unige.solidify.config;

import java.net.URL;
import java.net.URLClassLoader;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import ch.unige.solidify.service.GitInfoService;

@Service
public class SolidifyProperties {
  private static final Logger log = LoggerFactory.getLogger(SolidifyProperties.class);

  public static Logger getLog() {
    return log;
  }

  @Autowired
  private GitInfoService gitInfoService;

  @Value("${server.servlet.application-display-name:Default Server Display Name}")
  private String serverDisplayName;

  public String getApplicationName() {
    return this.gitInfoService.getAppName();
  }

  public String getApplicationVersion() {
    return this.gitInfoService.getBuildVersion();
  }

  public GitInfoService getGitInfoService() {
    return this.gitInfoService;
  }

  public String getServerDisplayName() {
    return this.serverDisplayName;
  }

  public void logClassPath() {
    final ClassLoader cl = ClassLoader.getSystemClassLoader();
    final URL[] urls = ((URLClassLoader) cl).getURLs();
    log.info("List CLASSPATH");
    for (final URL url : urls) {
      log.info(url.getFile());
    }
  }

}