package ch.unige.solidify.test.model;

import java.util.ArrayList;
import java.util.List;

public class OpenApiExtraDocumentation {
  private final String path;
  private final String schema;
  private final boolean normalResource;
  private List<OpenApiExtraDocumentationProperties> properties;

  public OpenApiExtraDocumentation(String path, String schema, boolean normal) {
    this.path = path;
    this.schema = schema;
    this.normalResource = normal;
    this.properties = new ArrayList<>();
  }

  public String getPath() {
    return this.path;
  }

  public List<OpenApiExtraDocumentationProperties> getProperties() {
    return this.properties;
  }

  public String getSchema() {
    return this.schema;
  }

  public boolean isNormalResource() {
    return this.normalResource;
  }

  public void setProperties(List<OpenApiExtraDocumentationProperties> properties) {
    this.properties = properties;
  }
}
