package ch.unige.solidify.converter;

import java.net.MalformedURLException;
import java.net.URL;

import javax.persistence.AttributeConverter;
import javax.persistence.Converter;

@Converter(autoApply = true)
public class UrlConverter implements AttributeConverter<URL, String> {

  @Override
  public String convertToDatabaseColumn(URL url) {
    return (url == null) ? null : url.toString();
  }

  @Override
  public URL convertToEntityAttribute(String stringUrl) {
    if (stringUrl == null) {
      return null;
    }
    try {
      return new URL(stringUrl);
    } catch (final MalformedURLException e) {
      throw new IllegalArgumentException(e.getMessage());
    }
  }
}
