package ch.unige.solidify.interceptor;

import java.io.IOException;

import org.springframework.http.HttpRequest;
import org.springframework.http.client.ClientHttpRequestExecution;
import org.springframework.http.client.ClientHttpRequestInterceptor;
import org.springframework.http.client.ClientHttpResponse;

public class BearerAuthorizationInterceptor implements ClientHttpRequestInterceptor {

  private static final String AUTHORIZATION = "Authorization";

  private final String token;

  public BearerAuthorizationInterceptor(String token) {
    this.token = token;
  }

  @Override
  public ClientHttpResponse intercept(HttpRequest request, byte[] body,
          ClientHttpRequestExecution execution) throws IOException {
    if (!request.getHeaders().containsKey(AUTHORIZATION)) {
      request.getHeaders().setBearerAuth(this.token);
    }
    return execution.execute(request, body);
  }
}
