package ch.unige.solidify.rest;

import java.util.Objects;

import org.springframework.hateoas.RepresentationModel;

public class Result extends RepresentationModel<Result> {

  public enum ActionStatus {
    EXECUTED, NON_APPLICABLE, NOT_EXECUTED
  }

  private String message;
  private final String resId;

  private ActionStatus status;

  public Result() {
    this.resId = null;
    this.status = ActionStatus.NON_APPLICABLE;
    this.message = null;
  }

  public Result(String id) {
    this.resId = id;
    this.status = ActionStatus.NON_APPLICABLE;
    this.message = null;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }
    if (!(obj instanceof Result)) {
      return false;
    }
    final Result result = (Result) obj;
    return super.equals(result) && Objects.equals(this.resId, result.getResId())
            && Objects.equals(this.status, result.getStatus())
            && Objects.equals(this.message, result.getMessage());
  }

  public String getMessage() {
    return this.message;
  }

  public String getResId() {
    return this.resId;
  }

  public ActionStatus getStatus() {
    return this.status;
  }

  @Override
  public int hashCode() {
    return Objects.hash(super.hashCode(), this.resId, this.status, this.message);
  }

  public void setMesssage(String m) {
    this.message = m;
  }

  public void setStatus(ActionStatus status) {
    this.status = status;
  }

}
