package ch.unige.solidify.rest;

import java.util.ArrayList;
import java.util.List;

import com.fasterxml.jackson.annotation.JsonIgnore;

/**
 * Interface used by Resources having sub resources
 */
public interface SubResourceContainer {

  <T> boolean addItem(T t);

  /**
   * Return a list of classes that are embedded sub Resources
   *
   * @return
   */
  @JsonIgnore
  default List<Class<? extends Resource<?>>> getEmbeddedResourceTypes() {
    return new ArrayList<>();
  }

  default <T> List<String> getSubResourceIds(Class<T> type) {
    return null;
  }

  <T> boolean removeItem(T t);

}
