package ch.unige.solidify.rest;

import org.springframework.hateoas.Link;
import org.springframework.web.util.UriComponentsBuilder;

import ch.unige.solidify.SolidifyConstants;

public class Tool {

  public static Link filter(UriComponentsBuilder ucb, String field, String value) {
    ucb.queryParam(field, value);
    return new Link(ucb.toUriString());
  }

  public static Link link(UriComponentsBuilder ucb) {
    return new Link(ucb.toUriString());
  }

  public static Link pageLink(UriComponentsBuilder ucb, long size, long page) {
    ucb.queryParam(ActionName.SIZE, size);
    ucb.queryParam(ActionName.PAGE, page);
    return new Link(ucb.toUriString());
  }

  public static Link parentLink(UriComponentsBuilder ucb) {
    final String uri = ucb.toUriString();
    final String parenturi = uri.substring(0, uri.lastIndexOf('/'));
    return new Link(parenturi);
  }

  public static Link referenceLink(UriComponentsBuilder ucb, String module) {
    final String uri = ucb.toUriString();
    final String[] list = uri.split("/");
    list[list.length - 5] = module;
    list[list.length - 4] = list[list.length - 2];
    list[list.length - 3] = list[list.length - 1];
    final StringBuilder refUri = new StringBuilder(list[0]);
    for (int i = 1; i < list.length - 2; i++) {
      refUri.append("/").append(list[i]);
    }
    return new Link(refUri.toString());
  }

  public static Link sort(UriComponentsBuilder ucb, String criterion) {
    ucb.queryParam(ActionName.SORT, criterion + ",desc");
    return new Link(ucb.toUriString());
  }

  private Tool() {
    throw new IllegalStateException(SolidifyConstants.TOOL_CLASS);
  }
}
